Index: trunk/zoo-project/zoo-kernel/oas.cfg
===================================================================
--- trunk/zoo-project/zoo-kernel/oas.cfg	(revision 967)
+++ trunk/zoo-project/zoo-kernel/oas.cfg	(revision 986)
@@ -1,16 +1,15 @@
 [openapi]
 use_content=false
-rootUrl=https://myserver/ogc-api
-links=/,/api,/conformance,/processes
-paths=/root,/api,/conformance,/processes,/processes/{id},/processes/{id}/jobs,/processes/{id}/jobs/{jobID},/processes/{id}/jobs/{jobID}/results
-parameters=id,jobID,resultID
+rootUrl=http://localhost/ogc-api
+links=/,/api,/conformance,/processes,/jobs
+paths=/root,/api,/conformance,/processes,/processes/{processID},/jobs,/jobs/{jobID},/jobs/{jobID}/results
+parameters=processID,jobID,resultID
 version=3.0.2
 license_name=OGC license
-license_url=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/LICENSE
-full_html_support=false
+license_url=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/LICENSE
+full_html_support=true
 partial_html_support=true
-wsUrl=wss://demo.mapmint.com:4430/
-publisherUrl=http://127.0.0.1/cgi-bin3/publish.py?jobid=
-io_as_array=true
+wsUrl=ws://localhost:8888/
+publisherUrl=http://localhost/cgi-bin/publish.py?jobid=
 
 [/]
@@ -25,5 +24,5 @@
 tags=Home
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/LandingPage.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/LandingPage.yaml
 
 [/index.html]
@@ -41,5 +40,5 @@
 
 [api.html]
-href=https://demo.mapmint.com/swagger-ui/ogc-api-processes/
+href=http://localhost/swagger-ui/oapip/
 
 [api]
@@ -62,5 +61,5 @@
 tags=Conformance
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ConformanceDeclaration.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ConformanceDeclaration.yaml
 
 [/conformance.html]
@@ -79,5 +78,5 @@
 tags=GetCapabilities
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ProcessList.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ProcessList.yaml
 
 [/processes.html]
@@ -85,5 +84,6 @@
 type=text/hml
 
-[processes/{id}]
+[processes/{processID}]
+length=2
 method=get
 title=retrieve a process description
@@ -91,24 +91,7 @@
 tags=ProcessDescription
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ProcessDescription.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ProcessDescription.yaml
 ecode=404
-parameters=/components/parameters/id
-
-
-[/processes/{id}/jobs]
-rel=canonical
-type=application/json
-title=Process Description
-
-[processes/{id}/jobs]
-length=2
-method=get
-title=retrieve a list of jobs run
-abstract=A list of jobs run.
-tags=JobList
-tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/JobList.yaml
-parameters=/components/parameters/id
-ecode=404,500
+parameters=/components/parameters/processID
 method_1=post
 title_1=execute a job
@@ -116,8 +99,33 @@
 tags_1=Execute Endpoint
 tags_description_1=
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ExecuteSync.yaml
-parameters_1=/components/parameters/id
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteSync.yaml
+parameters_1=/components/parameters/processID
 ecode_1=400,404,500
-eschema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ExecuteAsync.yaml
+eschema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteAsync.yaml
+
+[/jobs]
+rel=canonical
+type=application/json
+title=Job Management
+
+[jobs]
+length=1
+method=get
+title=retrieve a list of jobs run
+abstract=A list of jobs run.
+tags=JobList
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/JobList.yaml
+parameters=
+ecode=404,500
+method_1=post
+title_1=execute a job
+abstract_1=An execute endpoint.
+tags_1=ExecuteEndpoint
+tags_description_1=
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteSync.yaml
+parameters_1=
+ecode_1=400,404,500
+eschema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteAsync.yaml
 ep=,/components/parameters/oas-header1
 
@@ -125,12 +133,16 @@
 abstract=Mandatory execute request in JSON format
 type=application/json
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/execute.yaml
-
-[/processes/{id}/jobs/{jobID}]
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/execute.yaml
+
+[/jobs.html]
+rel=alternate
+type=text/hml
+
+[/jobs/{jobID}]
 rel=canonical
 type=application/json
 title=Status
 
-[processes/{id}/jobs/{jobID}]
+[jobs/{jobID}]
 length=2
 method=get
@@ -139,22 +151,21 @@
 tags=GetStatus
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/Status.yaml
-parameters=/components/parameters/id,/components/parameters/jobID
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
+parameters=/components/parameters/jobID
 method_1=delete
 title_1=Cancel a job
 abstract_1=Cancel the job execution.
 tags_1=Dismiss
-tags_description_1=Cencel a job execution
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/Status.yaml
-parameters_1=/components/parameters/id,/components/parameters/jobID
+tags_description_1=Cancel a job execution
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
+parameters_1=/components/parameters/jobID
 ecode_1=404,500
 
-
-[/processes/{id}/jobs/{jobID}/results]
+[/jobs/{jobID}/results]
 rel=canonical
 type=application/json
 title=Get Result
 
-[processes/{id}/jobs/{jobID}/results]
+[jobs/{jobID}/results]
 method=get
 title=The result of a job execution.
@@ -162,26 +173,10 @@
 tags=GetResult
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/Results.yaml
-parameters=/components/parameters/id,/components/parameters/jobID
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Results.yaml
+parameters=/components/parameters/jobID
 ecode=404,500
 ep=,/components/parameters/oas-header2
 
-[/processes/{id}/jobs/{jobID}/result/{resultID}]
-rel=canonical
-type=application/json
-title=Get Result
-
-[processes/{id}/jobs/{jobID}/result/{resultID}]
-method=get
-title=The result of a job execution.
-abstract=The result of a job execution.
-tags=GetResult
-tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/valueType.yaml
-parameters=/components/parameters/id,/components/parameters/jobID,/components/parameters/resultID
-ep=,/components/parameters/oas-header2
-
-
-[{id}]
+[{processID}]
 type=string
 title=The id of a process
@@ -214,5 +209,5 @@
 
 [conformsTo]
-rootUrl=http://www.opengis.net/spec/ogcapi-processes/1.0/conf/
+rootUrl=http://www.opengis.net/spec/ogcapi-processes/1.0/req/
 rootUrl0=http://www.opengis.net/spec/WPS/2.0/req/service/binding/rest-json/
 link=core
@@ -222,32 +217,34 @@
 link_4=dismiss
 link_5=callback
-length=6
+link_6=ogc-process-description
+link_7=html
+length=8
 
 [exception]
 abstract=Exception
 type=application/json
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/NotFound.yaml
-default_schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ServerError.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/responses/NotFound.yaml
+default_schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ServerError.yaml
 
 [responses]
 length=5
 code=404
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/NotFound.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/NotFound.yaml
 type=application/json
 title=NotFound
 code_1=500
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ServerError.yaml
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ServerError.yaml
 type_1=application/json
 title_1=ServerError
 code_2=400
-schema_2=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/InvalidParameter.yaml
+schema_2=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/InvalidParameter.yaml
 type_2=appliction/json
 title_2=InvalidParameter
 code_3=405
-schema_3=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/NotAllowed.yaml
+schema_3=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/NotAllowed.yaml
 type_3=appliction/json
 title_3=NotAllowed
 code_4=406
-schema_4=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/NotSupported.yaml
+schema_4=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/NotSupported.yaml
 type_4=appliction/json
 title_4=NotSupported
@@ -257,15 +254,15 @@
 state=jobSuccess
 uri=successUri
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/result.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/result.yaml
 type=application/json
 title=Results received successfully
 state_1=jobInProgress
 uri_1=inProgressUri
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/statusInfo.yaml
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/statusInfo.yaml
 type_1=application/json
-title_1=Results received successfully
+title_1=Status received successfully
 state_2=jobFailed
-uri_2=failedUrii
-schema_2=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/exception.yaml
+uri_2=failedUri
+schema_2=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/exception.yaml
 type_2=application/json
 title_2=Exception received successfully